/*
 * This file is part of the TYPO3 CMS project.
 *
 * It is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, either version 2
 * of the License, or any later version.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * The TYPO3 project - inspiring people to share!
 */
define(["require","exports","jquery","./Renderable/InfoBox","./Renderable/Severity","./Renderable/ProgressBar","./Module/PasswordStrength"],function(t,e,a,s,n,r,o){"use strict";return new(function(){function t(){var t=this;this.selectorBody=".t3js-body",this.selectorModuleContent=".t3js-module-content",this.selectorMainContent=".t3js-installer-content",this.selectorProgressBar=".t3js-installer-progress",this.selectorDatabaseConnectOutput=".t3js-installer-databaseConnect-output",this.selectorDatabaseSelectOutput=".t3js-installer-databaseSelect-output",this.selectorDatabaseDataOutput=".t3js-installer-databaseData-output",this.initializeEvents(),a(function(){t.initialize()})}return t.prototype.initializeEvents=function(){var t=this;a(document).on("click",".t3js-installer-environmentFolders-retry",function(e){e.preventDefault(),t.showEnvironmentAndFolders()}),a(document).on("click",".t3js-installer-environmentFolders-execute",function(e){e.preventDefault(),t.executeEnvironmentAndFolders()}),a(document).on("click",".t3js-installer-databaseConnect-execute",function(e){e.preventDefault(),t.executeDatabaseConnect()}),a(document).on("click",".t3js-installer-databaseSelect-execute",function(e){e.preventDefault(),t.executeDatabaseSelect()}),a(document).on("click",".t3js-installer-databaseData-execute",function(e){e.preventDefault(),t.executeDatabaseData()}),a(document).on("click",".t3js-installer-defaultConfiguration-execute",function(e){e.preventDefault(),t.executeDefaultConfiguration()}),a(document).on("keyup",".t3-install-form-password-strength",function(){o.initialize(".t3-install-form-password-strength")}),a(document).on("change","#t3js-connect-database-driver",function(t){var e=a(t.currentTarget).val();a(".t3-install-driver-data").hide(),a(".t3-install-driver-data input").attr("disabled","disabled"),a("#"+e+" input").attr("disabled",null),a("#"+e).show()})},t.prototype.initialize=function(){this.setProgress(0),this.getMainLayout()},t.prototype.getUrl=function(t){var e=location.href;return e=e.replace(location.search,""),void 0!==t&&(e=e+"?install[action]="+t),e},t.prototype.setProgress=function(t){var e=a(this.selectorProgressBar),s=0;0!==t&&(s=t/5*100,e.find(".progress-bar").empty().text(t+" / 5 - "+s+"% Complete")),e.find(".progress-bar").css("width",s+"%").attr("aria-valuenow",s)},t.prototype.getMainLayout=function(){var t=this;a.ajax({url:this.getUrl("mainLayout"),cache:!1,success:function(e){a(t.selectorBody).empty().append(e.html),t.checkInstallerAvailable()}})},t.prototype.checkInstallerAvailable=function(){var t=this;a.ajax({url:this.getUrl("checkInstallerAvailable"),cache:!1,success:function(e){e.success?t.checkEnvironmentAndFolders():t.showInstallerNotAvailable()}})},t.prototype.showInstallerNotAvailable=function(){var t=a(this.selectorMainContent);a.ajax({url:this.getUrl("showInstallerNotAvailable"),cache:!1,success:function(e){!0===e.success&&t.empty().append(e.html)}})},t.prototype.checkEnvironmentAndFolders=function(){var t=this;this.setProgress(1),a.ajax({url:this.getUrl("checkEnvironmentAndFolders"),cache:!1,success:function(e){!0===e.success?t.checkTrustedHostsPattern():t.showEnvironmentAndFolders()}})},t.prototype.showEnvironmentAndFolders=function(){var t=a(this.selectorMainContent);a.ajax({url:this.getUrl("showEnvironmentAndFolders"),cache:!1,success:function(e){if(!0===e.success){t.empty().html(e.html);var n=a(".t3js-installer-environment-details"),r=!1;Array.isArray(e.environmentStatusErrors)&&e.environmentStatusErrors.forEach(function(t){r=!0;var e=s.render(t.severity,t.title,t.message);n.append(e)}),Array.isArray(e.environmentStatusWarnings)&&e.environmentStatusWarnings.forEach(function(t){r=!0;var e=s.render(t.severity,t.title,t.message);n.append(e)}),Array.isArray(e.structureErrors)&&e.structureErrors.forEach(function(t){r=!0;var e=s.render(t.severity,t.title,t.message);n.append(e)}),r?(n.show(),a(".t3js-installer-environmentFolders-bad").show()):a(".t3js-installer-environmentFolders-good").show()}}})},t.prototype.executeEnvironmentAndFolders=function(){var t=this;a.ajax({url:this.getUrl("executeEnvironmentAndFolders"),cache:!1,success:function(e){!0===e.success&&t.checkTrustedHostsPattern()}})},t.prototype.checkTrustedHostsPattern=function(){var t=this;a.ajax({url:this.getUrl("checkTrustedHostsPattern"),cache:!1,success:function(e){!0===e.success?t.executeSilentConfigurationUpdate():t.executeAdjustTrustedHostsPattern()}})},t.prototype.executeAdjustTrustedHostsPattern=function(){var t=this;a.ajax({url:this.getUrl("executeAdjustTrustedHostsPattern"),cache:!1,success:function(){t.executeSilentConfigurationUpdate()}})},t.prototype.executeSilentConfigurationUpdate=function(){var t=this;a.ajax({url:this.getUrl("executeSilentConfigurationUpdate"),cache:!1,success:function(e){!0===e.success?t.checkDatabaseConnect():t.executeSilentConfigurationUpdate()}})},t.prototype.checkDatabaseConnect=function(){var t=this;this.setProgress(2),a.ajax({url:this.getUrl("checkDatabaseConnect"),cache:!1,success:function(e){!0===e.success?t.checkDatabaseSelect():t.showDatabaseConnect()}})},t.prototype.showDatabaseConnect=function(){var t=a(this.selectorMainContent);a.ajax({url:this.getUrl("showDatabaseConnect"),cache:!1,success:function(e){!0===e.success&&(t.empty().html(e.html),a("#t3js-connect-database-driver").trigger("change"))}})},t.prototype.executeDatabaseConnect=function(){var t=this,e=a(this.selectorDatabaseConnectOutput),n={"install[action]":"executeDatabaseConnect","install[token]":a(this.selectorModuleContent).data("installer-database-connect-execute-token")};a(a(this.selectorBody+" form").serializeArray()).each(function(t,e){n[e.name]=e.value}),a.ajax({url:this.getUrl(),cache:!1,method:"POST",data:n,success:function(a){!0===a.success?t.checkDatabaseSelect():Array.isArray(a.status)&&a.status.forEach(function(t){var a=s.render(t.severity,t.title,t.message);e.empty().append(a)})}})},t.prototype.checkDatabaseSelect=function(){var t=this;this.setProgress(3),a.ajax({url:this.getUrl("checkDatabaseSelect"),cache:!1,success:function(e){!0===e.success?t.checkDatabaseData():t.showDatabaseSelect()}})},t.prototype.showDatabaseSelect=function(){var t=a(this.selectorMainContent);a.ajax({url:this.getUrl("showDatabaseSelect"),cache:!1,success:function(e){!0===e.success&&t.empty().html(e.html)}})},t.prototype.executeDatabaseSelect=function(){var t=this,e=a(this.selectorDatabaseSelectOutput),n={"install[action]":"executeDatabaseSelect","install[token]":a(this.selectorModuleContent).data("installer-database-select-execute-token")};a(a(this.selectorBody+" form").serializeArray()).each(function(t,e){n[e.name]=e.value}),a.ajax({url:this.getUrl(),cache:!1,method:"POST",data:n,success:function(a){!0===a.success?t.checkDatabaseData():Array.isArray(a.status)&&a.status.forEach(function(t){var a=s.render(t.severity,t.title,t.message);e.empty().append(a)})}})},t.prototype.checkDatabaseData=function(){var t=this;this.setProgress(4),a.ajax({url:this.getUrl("checkDatabaseData"),cache:!1,success:function(e){!0===e.success?t.showDefaultConfiguration():t.showDatabaseData()}})},t.prototype.showDatabaseData=function(){var t=a(this.selectorMainContent);a.ajax({url:this.getUrl("showDatabaseData"),cache:!1,success:function(e){!0===e.success&&t.empty().html(e.html)}})},t.prototype.executeDatabaseData=function(){var t=this,e=a(this.selectorDatabaseDataOutput),o={"install[action]":"executeDatabaseData","install[token]":a(this.selectorModuleContent).data("installer-database-data-execute-token")};a(a(this.selectorBody+" form").serializeArray()).each(function(t,e){o[e.name]=e.value});var c=r.render(n.loading,"Loading...","");e.empty().html(c),a.ajax({url:this.getUrl(),cache:!1,method:"POST",data:o,success:function(a){!0===a.success?t.showDefaultConfiguration():Array.isArray(a.status)&&a.status.forEach(function(t){var a=s.render(t.severity,t.title,t.message);e.empty().append(a)})}})},t.prototype.showDefaultConfiguration=function(){var t=a(this.selectorMainContent);this.setProgress(5),a.ajax({url:this.getUrl("showDefaultConfiguration"),cache:!1,success:function(e){!0===e.success&&t.empty().html(e.html)}})},t.prototype.executeDefaultConfiguration=function(){var t={"install[action]":"executeDefaultConfiguration","install[token]":a(this.selectorModuleContent).data("installer-default-configuration-execute-token")};a(a(this.selectorBody+" form").serializeArray()).each(function(e,a){t[a.name]=a.value}),a.ajax({url:this.getUrl(),cache:!1,method:"POST",data:t,success:function(t){top.location.href=t.redirect}})},t}())});