/*
 * This file is part of the TYPO3 CMS project.
 *
 * It is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, either version 2
 * of the License, or any later version.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * The TYPO3 project - inspiring people to share!
 */
define(["require","exports","jquery","nprogress","TYPO3/CMS/Backend/Modal","TYPO3/CMS/Backend/Notification","TYPO3/CMS/Backend/Severity","TYPO3/CMS/Backend/jquery.clearable"],function(e,t,a,n,s,l,r){"use strict";var o,i;(i=o||(o={})).searchForm="#recycler-form",i.searchText="#recycler-form [name=search-text]",i.searchSubmitBtn="#recycler-form button[type=submit]",i.depthSelector="#recycler-form [name=depth]",i.tableSelector="#recycler-form [name=pages]",i.recyclerTable="#itemsInRecycler",i.paginator="#recycler-index nav",i.reloadAction="a[data-action=reload]",i.massUndo="button[data-action=massundo]",i.massDelete="button[data-action=massdelete]",i.toggleAll=".t3js-toggle-all";var c=function(){function e(){var e=this;this.elements={},this.paging={currentPage:1,totalPages:1,totalItems:0,itemsPerPage:TYPO3.settings.Recycler.pagingSize},this.markedRecordsForMassAction=[],this.allToggled=!1,this.handleCheckboxSelects=function(t){var n=a(t.currentTarget),s=n.parents("tr"),l=s.data("table")+":"+s.data("uid");if(n.prop("checked"))e.markedRecordsForMassAction.push(l),s.addClass("warning");else{var r=e.markedRecordsForMassAction.indexOf(l);r>-1&&e.markedRecordsForMassAction.splice(r,1),s.removeClass("warning")}if(e.markedRecordsForMassAction.length>0){e.elements.$massUndo.hasClass("disabled")&&e.elements.$massUndo.removeClass("disabled").removeAttr("disabled"),e.elements.$massDelete.hasClass("disabled")&&e.elements.$massDelete.removeClass("disabled").removeAttr("disabled");var o=e.createMessage(TYPO3.lang["button.undoselected"],[e.markedRecordsForMassAction.length]),i=e.createMessage(TYPO3.lang["button.deleteselected"],[e.markedRecordsForMassAction.length]);e.elements.$massUndo.find("span.text").text(o),e.elements.$massDelete.find("span.text").text(i)}else e.resetMassActionButtons()},this.deleteRecord=function(t){if(!TYPO3.settings.Recycler.deleteDisable){var n,l,o=a(t.currentTarget).parents("tr"),i="TBODY"!==o.parent().prop("tagName");if(i)n=e.markedRecordsForMassAction,l=TYPO3.lang["modal.massdelete.text"];else{var c=o.data("uid"),d=o.data("table"),g=o.data("recordtitle");n=[d+":"+c],l="pages"===d?TYPO3.lang["modal.deletepage.text"]:TYPO3.lang["modal.deletecontent.text"],l=e.createMessage(l,[g,"["+n[0]+"]"])}s.confirm(TYPO3.lang["modal.delete.header"],l,r.error,[{text:TYPO3.lang["button.cancel"],btnClass:"btn-default",trigger:function(){s.dismiss()}},{text:TYPO3.lang["button.delete"],btnClass:"btn-danger",trigger:function(){e.callAjaxAction("delete",n,i)}}])}},this.undoRecord=function(t){var n,l,o,i=a(t.currentTarget).parents("tr"),c="TBODY"!==i.parent().prop("tagName");if(c)n=e.markedRecordsForMassAction,l=TYPO3.lang["modal.massundo.text"],o=!0;else{var d=i.data("uid"),g=i.data("table"),p=i.data("recordtitle");n=[g+":"+d],l=(o="pages"===g)?TYPO3.lang["modal.undopage.text"]:TYPO3.lang["modal.undocontent.text"],l=e.createMessage(l,[p,"["+n[0]+"]"]),o&&i.data("parentDeleted")&&(l+=TYPO3.lang["modal.undo.parentpages"])}var m=null;m=o?a("<div />").append(a("<p />").text(l),a("<div />",{class:"checkbox"}).append(a("<label />").append(TYPO3.lang["modal.undo.recursive"]).prepend(a("<input />",{id:"undo-recursive",type:"checkbox"})))):a("<p />").text(l),s.confirm(TYPO3.lang["modal.undo.header"],m,r.ok,[{text:TYPO3.lang["button.cancel"],btnClass:"btn-default",trigger:function(){s.dismiss()}},{text:TYPO3.lang["button.undo"],btnClass:"btn-success",trigger:function(){e.callAjaxAction("undo","object"==typeof n?n:[n],c,m.find("#undo-recursive").prop("checked"))}}])},a(function(){e.initialize()})}return e.refreshPageTree=function(){top.TYPO3&&top.TYPO3.Backend&&top.TYPO3.Backend.NavigationContainer&&top.TYPO3.Backend.NavigationContainer.PageTree&&top.TYPO3.Backend.NavigationContainer.PageTree.refreshTree()},e.prototype.getElements=function(){this.elements={$searchForm:a(o.searchForm),$searchTextField:a(o.searchText),$searchSubmitBtn:a(o.searchSubmitBtn),$depthSelector:a(o.depthSelector),$tableSelector:a(o.tableSelector),$recyclerTable:a(o.recyclerTable),$tableBody:a(o.recyclerTable).find("tbody"),$paginator:a(o.paginator),$reloadAction:a(o.reloadAction),$massUndo:a(o.massUndo),$massDelete:a(o.massDelete),$toggleAll:a(o.toggleAll)}},e.prototype.registerEvents=function(){var e=this;this.elements.$searchForm.on("submit",function(t){t.preventDefault(),""!==e.elements.$searchTextField.val()&&e.loadDeletedElements()}),this.elements.$searchTextField.on("keyup",function(t){""!==a(t.currentTarget).val()?e.elements.$searchSubmitBtn.removeClass("disabled"):(e.elements.$searchSubmitBtn.addClass("disabled"),e.loadDeletedElements())}).clearable({onClear:function(){e.elements.$searchSubmitBtn.addClass("disabled"),e.loadDeletedElements()}}),this.elements.$depthSelector.on("change",function(){a.when(e.loadAvailableTables()).done(function(){e.loadDeletedElements()})}),this.elements.$tableSelector.on("change",function(){e.paging.currentPage=1,e.loadDeletedElements()}),this.elements.$recyclerTable.on("click","[data-action=undo]",this.undoRecord),this.elements.$recyclerTable.on("click","[data-action=delete]",this.deleteRecord),this.elements.$reloadAction.on("click",function(t){t.preventDefault(),a.when(e.loadAvailableTables()).done(function(){e.loadDeletedElements()})}),this.elements.$paginator.on("click","a[data-action]",function(t){t.preventDefault();var n=a(t.currentTarget),s=!1;switch(n.data("action")){case"previous":e.paging.currentPage>1&&(e.paging.currentPage--,s=!0);break;case"next":e.paging.currentPage<e.paging.totalPages&&(e.paging.currentPage++,s=!0);break;case"page":e.paging.currentPage=parseInt(n.find("span").text(),10),s=!0}s&&e.loadDeletedElements()}),TYPO3.settings.Recycler.deleteDisable?this.elements.$massDelete.remove():this.elements.$massDelete.show(),this.elements.$recyclerTable.on("show.bs.collapse hide.bs.collapse","tr.collapse",function(e){var t,n,s=a(e.currentTarget).prev("tr").find("[data-action=expand]").find(".t3-icon");switch(e.type){case"show":t="t3-icon-pagetree-collapse",n="t3-icon-pagetree-expand";break;case"hide":t="t3-icon-pagetree-expand",n="t3-icon-pagetree-collapse"}s.removeClass(t).addClass(n)}),this.elements.$toggleAll.on("click",function(){e.allToggled=!e.allToggled,a('input[type="checkbox"]').prop("checked",e.allToggled).trigger("change")}),this.elements.$recyclerTable.on("change","tr input[type=checkbox]",this.handleCheckboxSelects),this.elements.$massUndo.on("click",this.undoRecord),this.elements.$massDelete.on("click",this.deleteRecord)},e.prototype.initialize=function(){var e=this;n.configure({parent:".module-loading-indicator",showSpinner:!1}),this.getElements(),this.registerEvents(),TYPO3.settings.Recycler.depthSelection>0?this.elements.$depthSelector.val(TYPO3.settings.Recycler.depthSelection).trigger("change"):a.when(this.loadAvailableTables()).done(function(){e.loadDeletedElements()})},e.prototype.resetMassActionButtons=function(){this.markedRecordsForMassAction=[],this.elements.$massUndo.addClass("disabled").attr("disabled",!0),this.elements.$massUndo.find("span.text").text(TYPO3.lang["button.undo"]),this.elements.$massDelete.addClass("disabled").attr("disabled",!0),this.elements.$massDelete.find("span.text").text(TYPO3.lang["button.delete"])},e.prototype.loadAvailableTables=function(){var e=this;return a.ajax({url:TYPO3.settings.ajaxUrls.recycler,dataType:"json",data:{action:"getTables",startUid:TYPO3.settings.Recycler.startUid,depth:this.elements.$depthSelector.find("option:selected").val()},beforeSend:function(){n.start(),e.elements.$tableSelector.val(""),e.paging.currentPage=1},success:function(t){var n=[];e.elements.$tableSelector.children().remove(),a.each(t,function(e,t){var s=t[0],l=t[1],r=(t[2]?t[2]:TYPO3.lang.label_allrecordtypes)+" ("+l+")";n.push(a("<option />").val(s).text(r))}),n.length>0&&(e.elements.$tableSelector.append(n),""!==TYPO3.settings.Recycler.tableSelection&&e.elements.$tableSelector.val(TYPO3.settings.Recycler.tableSelection))},complete:function(){n.done()}})},e.prototype.loadDeletedElements=function(){var e=this;return a.ajax({url:TYPO3.settings.ajaxUrls.recycler,dataType:"json",data:{action:"getDeletedRecords",depth:this.elements.$depthSelector.find("option:selected").val(),startUid:TYPO3.settings.Recycler.startUid,table:this.elements.$tableSelector.find("option:selected").val(),filterTxt:this.elements.$searchTextField.val(),start:(this.paging.currentPage-1)*this.paging.itemsPerPage,limit:this.paging.itemsPerPage},beforeSend:function(){n.start(),e.resetMassActionButtons()},success:function(t){e.elements.$tableBody.html(t.rows),e.buildPaginator(t.totalItems)},complete:function(){n.done()}})},e.prototype.callAjaxAction=function(t,r,o,i){var c=this;void 0===i&&(i=!1);var d={records:r,action:""},g=!1;if("undo"===t)d.action="undoRecords",d.recursive=i?1:0,g=!0;else{if("delete"!==t)return;d.action="deleteRecords"}a.ajax({url:TYPO3.settings.ajaxUrls.recycler,type:"POST",dataType:"json",data:d,beforeSend:function(){n.start()},success:function(t){t.success?l.success("",t.message):l.error("",t.message),c.paging.currentPage=1,a.when(c.loadAvailableTables()).done(function(){c.loadDeletedElements(),o&&c.resetMassActionButtons(),g&&e.refreshPageTree(),c.allToggled=!1})},complete:function(){s.dismiss(),n.done()}})},e.prototype.createMessage=function(e,t){return void 0===e?"":e.replace(/\{([0-9]+)\}/g,function(e,a){return t[a]})},e.prototype.buildPaginator=function(e){if(0!==e)if(this.paging.totalItems=e,this.paging.totalPages=Math.ceil(e/this.paging.itemsPerPage),1!==this.paging.totalPages){var t=a("<ul />",{class:"pagination pagination-block"}),n=[],s=a("<li />").append(a("<a />",{"data-action":"previous"}).append(a("<span />",{class:"t3-icon fa fa-arrow-left"}))),l=a("<li />").append(a("<a />",{"data-action":"next"}).append(a("<span />",{class:"t3-icon fa fa-arrow-right"})));1===this.paging.currentPage&&s.disablePagingAction(),this.paging.currentPage===this.paging.totalPages&&l.disablePagingAction();for(var r=1;r<=this.paging.totalPages;r++){var o=a("<li />",{class:this.paging.currentPage===r?"active":""});o.append(a("<a />",{"data-action":"page"}).append(a("<span />").text(r))),n.push(o)}t.append(s,n,l),this.elements.$paginator.html(t)}else this.elements.$paginator.contents().remove();else this.elements.$paginator.contents().remove()},e}();return a.fn.disablePagingAction=function(){a(this).addClass("disabled").find(".t3-icon").unwrap().wrap(a("<span />"))},new c});